/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>
#include <stdio.h>

typedef struct worm worm;
struct worm {
	Point *p;
	ushort len;
	ushort head;
	Point last;
};

typedef struct worms worms;
struct worms {
	worm **w;
	ushort len;
};

worms *worm_l;
ushort num_w, len_w, thick;
Point middle;

void
free_worm(worm *w)
{
	if(w != nil) {
		if(w->p != nil)
			free(w->p);
		free(w);
	}
	return;
}

void
free_worms(worms *w)
{
	if(w != nil) {
		while(w->len-- > 0)
			if(w->w[w->len] != nil)
				free_worm(w->w[w->len]);
		free(w);
	}
	return;
}

void *
wrealloc(void *ptr, ulong size)
{
	char *ret;

	ret = realloc(ptr, size);
	if(ret == nil) {
		perror("realloc");
		if(worm_l != nil)
			free_worms(worm_l);
		exits(0);
	}
	return (void *)ret;
}

worm *
mk_worm(ushort len)
{
	worm *ret;

	ret = wrealloc(nil, sizeof(worm));
	memset(ret, 0, sizeof(worm));
	while(len-- > 0) {
		ret->len++;
		ret->p = wrealloc(ret->p, ret->len * sizeof(Point));
		ret->p[ret->len - 1] = middle;
	}
	ret->head = 0;
	ret->last.x = nrand(3) - 1;
	ret->last.y = nrand(3) - 1;
	return ret;
}

worms *
mk_worms(ushort num, ushort len)
{
	worms *ret;

	ret = wrealloc(nil, sizeof(worms));
	memset(ret, 0, sizeof(worms));

	while(num-- > 0) {
		ret->len++;
		ret->w = wrealloc(ret->w, ret->len * sizeof(worm *));
		ret->w[ret->len - 1] = mk_worm(len);
	}
	return ret;
}

void
move_worm(worm *w)
{
	Point *bef;

	if(w != nil && w->p != nil) {
		bef = &w->p[w->head];
		if(w->head == 0)
			w->head = w->len;
		w->head--;
		fillellipse(screen, w->p[w->head], thick,
					thick, display->black, ZP);
		if(nrand(128) > 100) {
			if(nrand(2) == 0) {
				w->last.x = nrand(3) - 1;
				if(w->last.x == 0 && w->last.y == 0)
					w->last.x = -1;
			} else {
				w->last.y = nrand(3) - 1;
				if(w->last.x == 0 && w->last.y == 0)
					w->last.y = -1;
			}
		}
		w->p[w->head].x = bef->x + w->last.x;
		w->p[w->head].y = bef->y + w->last.y;

		if(w->p[w->head].x > screen->r.max.x)
			w->p[w->head].x = screen->r.min.x;
		if(w->p[w->head].x < screen->r.min.x)
			w->p[w->head].x = screen->r.max.x;
		if(w->p[w->head].y > screen->r.max.y)
			w->p[w->head].y = screen->r.min.y;
		if(w->p[w->head].y < screen->r.min.y)
			w->p[w->head].y = screen->r.max.y;

		fillellipse(screen, w->p[w->head], thick,
					thick, display->white, ZP);
	}
	return;
}

void
move_worms(worms *w)
{
	ushort i;

	i = 0;
	while(i < w->len)
		move_worm(w->w[i++]);

	return;
}

void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0) {
		sysfatal("can't reattach to window");
	}

	draw(screen, screen->r, display->black, nil, ZP);

	middle.x = (short)(screen->r.max.x - screen->r.min.x) / 2 +
				screen->r.min.x;
	middle.y = (short)(screen->r.max.y - screen->r.min.y) / 2 +
				screen->r.min.y;

	if(worm_l != nil)
		free_worms(worm_l);
	worm_l = mk_worms(num_w, len_w);
	return;
}

char *buttons[] = 
{
	"exit",
	0
};

Menu menu = 
{
	buttons
};

void
usage(void)
{
	print("usage: 9worm [-n num]"
			" [-t thickness] [-l len]\n");
	return;
}

void 
main(int argc, char **argv)
{
	Mouse m;

	srand(time(0));

	num_w = 50;
	len_w = 32;
	thick = 1;

	ARGBEGIN {
		case 'n':
			num_w = atoi(ARGF());
			break;
		case 't':
			thick = atoi(ARGF());
			break;
		case 'l':
			len_w = atoi(ARGF());
			break;
		default:
			usage();
			exits(0);
	} ARGEND;
		
	if(initdraw(nil, nil, "9worm") < 0)
		sysfatal("initdraw failed: %r");

	einit(Emouse);

	eresized(0);
	while(1) {
		if(ecanmouse()) {
			m = emouse();
			if(m.buttons&4)
				if(emenuhit(3, &m, &menu) == 0) {
					exits(0);
				}
		}
		move_worms(worm_l);
	}
	free_worms(worm_l);
	exits(0);
}